'use strict';

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function preset(api, _ref) {
  let {
    loose = true,
    useBuiltIns = true,
    proposal = "smart"
  } = _ref,
      overrides = _objectWithoutProperties(_ref, ["loose", "useBuiltIns", "proposal"]);

  let plugin;

  plugin = function (name, options) {
    let instance;
    instance = require.resolve(name);
    return options || name in overrides ? [instance, Object.assign({}, options, overrides[name])] : instance;
  };

  return {
    plugins: [plugin("@babel/plugin-proposal-function-bind"), plugin("@babel/plugin-proposal-do-expressions"), plugin("@babel/plugin-proposal-export-default-from"), plugin("@babel/plugin-proposal-nullish-coalescing-operator", {
      loose
    }), plugin("@babel/plugin-proposal-optional-chaining", {
      loose
    }), plugin("@babel/plugin-proposal-partial-application"), plugin("@babel/plugin-proposal-pipeline-operator", {
      proposal
    }), plugin("@babel/plugin-proposal-export-namespace-from"), plugin("@babel/plugin-proposal-function-sent"), plugin("@babel/plugin-proposal-numeric-separator"), plugin("@babel/plugin-proposal-throw-expressions"), plugin("@babel/plugin-proposal-async-generator-functions"), plugin("@babel/plugin-proposal-object-rest-spread", {
      useBuiltIns
    }), plugin("@babel/plugin-proposal-optional-catch-binding"), plugin("@babel/plugin-proposal-unicode-property-regex"), plugin("@babel/plugin-syntax-dynamic-import"), plugin("@babel/plugin-syntax-import-meta")]
  };
}

module.exports = preset;
